Magellan Linux

Diff of /alx-src/trunk/alxinstall-ng/bin/alxinstall-ng.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

alx-src/trunk/alxinstall-ng/bin/alxinstall-ng.sh revision 527 by niro, Fri Jun 27 23:33:40 2008 UTC alx-src/trunk/alxinstall-ng/bin/alxinstall-ng.sh.in revision 6838 by niro, Thu Jul 23 12:51:57 2015 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  # $Id$
 # $Header: /home/cvsd/alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.13 2008-06-27 23:33:40 niro Exp $  
 #  
 # AutoSta_LX Installation Script  
 #  
 # Niels Rogalla <niro@magellan-linux.de>  
 # <rogalla@augusta-bochum.de>  
 #  
 #  
 # Install Navigation Gui  
 #  
3    
4  #images: (get ${CDIMAGENAME})  # ignore environment!
5    LC_ALL=C
6    
7    MLIBDIR="/usr/lib/alxinstall-ng"
8    
9    # images: (get ${CDIMAGENAME})
10  source /mnt/cdrom/system/images.conf  source /mnt/cdrom/system/images.conf
11    
12  #Includes  # includes
13  source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null  source ${MLIBDIR}/functions/generic.sh
14  ### bugfix ###############################  source ${MLIBDIR}/functions/hwdetection.sh
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
15    
16  ### System/Config Version  ### System/Config Version
17  VERSION="0.3"  VERSION="@@VERSION@@"
18  TITLE="alxinstall-ng - ${VERSION}"  TITLE="alxinstall-ng - ${VERSION}"
19    
20    # locations
21  CDPATH="/mnt/cdrom"  CDPATH="/mnt/cdrom"
22  INSTALLPATH="/mnt/magellan"  INSTALL_ROOT="/mnt/magellan"
23    
24  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # default system settings
25    # standard kernel opts
26    DEFAULT_KERNELOPTS="quiet video=1024x768"
27    
28    # grub options
29    DEFAULT_GRUBLEGACYOPTS=""
30    DEFAULT_GRUB2OPTS=""
31    DEFAULT_GRUB2GFXPAYLOAD="1024x768x16,1024x768"
32    
33    # default specialdevices
34    DEFAULT_FORMFACTOR="desktop"
35    
36    # target filesystem
37    DEFAULT_FORMAT_FILESYSTEM="ext4"
38    
39    # initialize global variables so they are exportable
40    INSTALL_METHOD=""
41    KERNELOPTS=""
42    GRUBLEGACYOPTS=""
43    GRUB2OPTS=""
44    GRUB2GFXPAYLOAD=""
45    FORMFACTOR=""
46    FORMAT_FILESYSTEM=""
47    FDISKPARTIONBELOW256MB=0
48    SPECIALDEVICE=""
49    FLASHDISK=0
50    ### linecount of system.tar.gz -1 !
51  CURRENTLINE=0  CURRENTLINE=0
52  #TOTALLINES=11072 # -> now in images.conf  #TOTALLINES=11072 # -> now in images.conf
53    
   
54  #################################################  #################################################
55  #  DIALOG BOXEN #  #  DIALOG BOXES #
56  #################################################  #################################################
57    
58  die()  die()
# Line 41  die() Line 60  die()
60   ERROR=$1   ERROR=$1
61   RETVAL=$?   RETVAL=$?
62   dialog_install_failure   dialog_install_failure
63     trap_exit
64   exit 1   exit 1
65  }  }
66    
# Line 64  dialog_warning() Line 84  dialog_warning()
84    
85  dialog_setup_hdd_info()  dialog_setup_hdd_info()
86  {  {
87     case "${INSTALL_METHOD}" in
88     auto)
89     dialog_setup_hdd_info_auto
90     dialog_setup_hdd_create_partitions
91     ;;
92     normal) dialog_setup_hdd_info_normal ;;
93     single) dialog_setup_hdd_info_single ;;
94     flash) dialog_setup_hdd_info_flash ;;
95     esac
96    }
97    
98    dialog_setup_hdd_info_normal()
99    {
100   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
101    
102   dialog \   dialog \
# Line 78  dialog_setup_hdd_info() Line 111  dialog_setup_hdd_info()
111   Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81   Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
112  }  }
113    
114  dialog_setup_hdd_info_flash()  dialog_setup_hdd_info_single()
115  {  {
116   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
117    
# Line 92  dialog_setup_hdd_info_flash() Line 125  dialog_setup_hdd_info_flash()
125   Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81   Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
126  }  }
127    
128    dialog_setup_hdd_info_flash()
129    {
130     local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
131    
132     dialog \
133     --colors \
134     --title "[ Festplatten Partitionierung ]" \
135     --backtitle "${TITLE}" \
136     --ok-label "Weiter" \
137     --msgbox "\nBitte legen Sie 2 Partitionen an.\n\n\
138     [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
139     [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
140     Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
141    }
142    
143    dialog_setup_hdd_info_auto()
144    {
145     local SHDD="$(echo $HDD | sed 's/\/dev\///')"
146    
147     dialog \
148     --colors \
149     --title "[ Festplatten Partitionierung ]" \
150     --backtitle "${TITLE}" \
151     --ok-label "Weiter" \
152     --msgbox "\nAchtung!\n\
153     Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81
154    }
155    
156  dialog_setup_system_menu()  dialog_setup_system_menu()
157  {  {
158   local i   local i
# Line 102  dialog_setup_system_menu() Line 163  dialog_setup_system_menu()
163   --cancel-label "Abbrechen" \   --cancel-label "Abbrechen" \
164   --ok-label "Weiter" \   --ok-label "Weiter" \
165   --stdout \   --stdout \
166     --colors \
167   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \
168   "1" "Normale IDE-Disk" \   "1" "Automatisches Setup (Empfohlen)" \
169   "2" "Flash-Speicher")   "" "" \
170     "" "\Z1Experten Modi:\Zn" \
171     "2" "Normale IDE-Disk (Manuell)" \
172     "3" "Normale IDE Disk (Single)" \
173     "4" "Flash SDHC/NAND oder USBStick (Manuell)")
174   RES=$?   RES=$?
175   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
176   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
177   then   then
178   case "${i}" in   case "${i}" in
179           "1") run_install_normal ;;   "1") run_install auto ;;
180   "2") run_install_flash ;;   "2") run_install normal ;;
181     "3") run_install single ;;
182     "3") run_install flash ;;
183     "") dialog_setup_system_menu;;
184   esac   esac
185   fi   fi
186  }  }
187    
188  dialog_setup_hdd_found_manuell()  dialog_hardware_detection()
189  {  {
190   local i   local i
191     local hwtmp
192    
193     if [ -x $(type -P mktemp) ]
194     then
195     hwtmp="$(mktemp)"
196     else
197     hwtmp="/tmp/hwtmp.sh"
198     fi
199    
200   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
201    
202   echo "dialog \\"  > /tmp/hddtmp.sh   echo "dialog \\"  > ${hwtmp}
203   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
204   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   echo "--ok-label \"Weiter\" \\" >> ${hwtmp}
205   echo "--stdout \\" >> /tmp/hddtmp.sh   echo "--stdout \\" >> ${hwtmp}
206   echo "--colors \\" >> /tmp/hddtmp.sh   echo "--colors \\" >> ${hwtmp}
207   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> /tmp/hddtmp.sh   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
208   echo " Festplatten:\n \\" >> /tmp/hddtmp.sh   echo " Festplatten:\n \\" >> ${hwtmp}
209    
210   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
211   then   then
212   for i in ${scsidisks}   for i in ${ALL_DISKS}
213   do   do
214   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> /tmp/hddtmp.sh  
  installdevs="${installdevs} ${i}"  
  fi  
215   done   done
216   fi   fi
217    
218   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
219   then   then
220   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
221     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
222     for i in ${ALL_CDROMS}
223   do   do
224   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> /tmp/hddtmp.sh  
  installdevs="${installdevs} ${i}"  
  fi  
225   done   done
226   fi   fi
227    
228   if [[ ! -z ${cdromdev} ]]   # other devices
229     run_hardware_detection
230     case "${SPECIALDEVICE}" in
231     zotac*) echo " \n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;
232     rangee) echo " \n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;
233     maxdata) echo " \n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;
234     i845) echo " \n \\Z2Intel i845 Device erkannt.\\Zn \\" >> ${hwtmp} ;;
235     *) echo " \n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;
236     esac
237     if [[ ${FORMFACTOR} = laptop ]]
238   then   then
239   echo " \n \\" >> /tmp/hddtmp.sh   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}
  echo " \\Z7andere Laufwerke:\n \\" >> /tmp/hddtmp.sh  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> /tmp/hddtmp.sh  
240   fi   fi
241   echo " \" 13 70" >> /tmp/hddtmp.sh   if [[ ${FLASHDISK} = 1 ]]
  chmod a+x /tmp/hddtmp.sh  
  /tmp/hddtmp.sh  
 }  
   
 dialog_setup_hdd_partitions_manuell()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
242   then   then
243   dialog \   echo " \n \\ZnFlash Speicher erkannt, F2FS wird als Dateisystem benutzt.\\Zn \\" >> ${hwtmp}
244   --backtitle "${TITLE}" \   fi
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
245    
246   for i in ${installdevs}   echo " \" 14 70" >> ${hwtmp}
247   do   chmod a+x ${hwtmp}
248   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh   ${hwtmp}
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
249    
250   chmod a+x /tmp/hddtmp.sh   # remove tmp file
251   HDD="$(/tmp/hddtmp.sh)"   if [[ -f ${hwtmp} ]]
252   RES=$?   then
253   [[ ${RES} -eq 1 ]] && return 1   rm ${hwtmp}
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manuell  
  fi  
254   fi   fi
255  }  }
256    
257  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions()
258  {  {
259   local i   local i
260    
261   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
262   then   then
263   dialog \   dialog \
264   --backtitle "${TITLE}" \   --backtitle "${TITLE}" \
# Line 223  dialog_setup_hdd_partitions_manuell_flas Line 274  dialog_setup_hdd_partitions_manuell_flas
274   echo "--stdout \\" >> /tmp/hddtmp.sh   echo "--stdout \\" >> /tmp/hddtmp.sh
275   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
276    
277   for i in ${installdevs}   for i in ${ALL_DISKS}
278   do   do
279   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
280   done   done
# Line 235  dialog_setup_hdd_partitions_manuell_flas Line 286  dialog_setup_hdd_partitions_manuell_flas
286   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
287   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
288   then   then
289   dialog_setup_hdd_info_flash   dialog_setup_hdd_info
290   setup_hdd_partitions_manuell_flash   setup_hdd_partitions
291   fi   fi
292   fi   fi
293  }  }
294    
295    dialog_setup_hdd_create_partitions()
296    {
297     dialog \
298     --backtitle "${TITLE}" \
299     --infobox "Erstelle Disk Partitionen ..." 3 70
300    }
301    
302  dialog_setup_hdd_format()  dialog_setup_hdd_format()
303  {  {
304   dialog \   dialog \
# Line 275  dialog_install_meter() Line 333  dialog_install_meter()
333   return 0   return 0
334  }  }
335    
   
336  dialog_install_bootsector()  dialog_install_bootsector()
337  {  {
338   dialog \   dialog \
# Line 322  dialog_main() Line 379  dialog_main()
379   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
380   then   then
381   case ${METHOD} in   case ${METHOD} in
382           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
383   "2") dialog_setup_hdd_found_manuell ;;   "2") dialog_hardware_detection ;;
384   "3") install_do_reboot ;;   "3") install_do_reboot ;;
385   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
386   esac   esac
# Line 332  dialog_main() Line 389  dialog_main()
389  }  }
390    
391  #################################################  #################################################
392  # Install Komandos #  # Install Commands #
393  #################################################  #################################################
394  setup_hdd_partitions_manuell()  run_hardware_detection()
395    {
396     local hwinfo
397     hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
398    
399     # check for special devices/clients:
400     # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
401     local removable=0
402     if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
403     then
404     for i in /sys/block/[hs]d*/removable
405     do
406     if [[ $(< ${i}) = 1 ]]
407     then
408     removable=1
409     # we assume that all removable disks are flash disks
410     export FLASHDISK=1
411     fi
412     done
413    
414     # only add this for grub legacy, grub2 detect these settings on its own
415     export GRUBLEGACYOPTS="rootdelay=8"
416     # there are two zotac types in the wild, nvidia based gfx and intel
417     if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
418     then
419     export SPECIALDEVICE="zotac_nvidia"
420     else
421     export SPECIALDEVICE="zotac_intel"
422     fi
423     fi
424    
425     # check for special devices/clients:
426     # if a rangee and disk ist smaller then 256mb move partion one block further ahead
427     if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
428     then
429     # for a rangee always define partion startblock +1
430     export FDISKPARTIONBELOW256MB="1"
431     export SPECIALDEVICE="rangee"
432     export GRUBLEGACYOPTS=""
433     fi
434    
435     # check for special devices/clients:
436     # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
437     if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
438     then
439     export SPECIALDEVICE="maxdata"
440     export GRUBLEGACYOPTS=""
441     fi
442    
443     # check for i845 Chipsets and disable KMS and use 915 drm driver
444     if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
445     then
446     export SPECIALDEVICE="i845"
447     # unset default video=1024x768 opt or the drm driver breaks
448     export KERNELOPTS="quiet"
449     export GRUBLEGACYOPTS=""
450     # enable full kms support
451     export GRUB2GFXPAYLOAD="keep"
452     fi
453    
454     # check for radeon gfxcards
455     if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
456     then
457     # enable full kms support
458     export GRUB2GFXPAYLOAD="keep"
459     fi
460    
461     # check for special devices/clients:
462     # check for laptops and activate cpufreq scaling
463     if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
464     then
465     export FORMFACTOR="laptop"
466     export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
467     fi
468    }
469    
470    run_hardware_detection_disks()
471  {  {
472   BOOTHDD="${HDD}1"   local bootdev
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
473    
474   ## hdds partitionieren manuell   # all disks but exclude ramdisks
475   cfdisk ${HDD} || die   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
476     # remove the boot device from ALL_DISKS if it was an usbstick
477     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
478     then
479     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
480     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
481     fi
482     export ALL_CDROMS="$(get_hwinfo cdrom)"
483  }  }
484    
485  setup_hdd_partitions_manuell_flash()  hdd_size_below_256mb()
486  {  {
487   ROOTHDD="${HDD}1"   local hdd="$1"
488     local size
489     local retval
490     [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"
491    
492     size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
493     if [[ ${size} -le 257000000 ]]
494     then
495     retval="0"
496     else
497     retval="1"
498     fi
499    
500   ## hdds partitionieren manuell   return "${retval}"
  cfdisk ${HDD} || die  
501  }  }
502    
503  setup_hdd_format()  setup_hdd_partitions()
504  {  {
505   mkswap ${SWAPHDD} || die   case "${INSTALL_METHOD}" in
506   mke2fs -j -q ${BOOTHDD} || die   normal)
507   mke2fs -j -q ${ROOTHDD} || die   BOOTHDD="${HDD}1"
508     SWAPHDD="${HDD}2"
509     ROOTHDD="${HDD}3"
510     ;;
511    
512     single|auto)
513     BOOTHDD=""
514     SWAPHDD=""
515     ROOTHDD="${HDD}1"
516     ;;
517    
518     flash)
519     BOOTHDD="${HDD}1"
520     SWAPHDD=""
521     ROOTHDD="${HDD}2"
522     ;;
523     esac
524    
525     if [[ ${INSTALL_METHOD} = auto ]]
526     then
527     # run this only if FDISKPARTITIONBELOW256MB is not already 1
528     if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
529     then
530     if hdd_size_below_256mb ${HDD}
531     then
532     FDISKPARTIONBELOW256MB=1
533     else
534     FDISKPARTIONBELOW256MB=0
535     fi
536     fi
537    
538     ## delete disk
539     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die
540    
541     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
542     then
543     ## setup one bootable partition
544     #1. n= new disk
545     #2. p= primary disk
546     #3. 1= first partition
547     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
548     #5. ''= defaul sector end
549     #6. a= bootable flag
550     #7. 1= boot flag for partition 1
551     #8. w= write/quit
552     fdisk ${HDD} &> /dev/null << EOF
553    n
554    p
555    1
556    2
557    
558    a
559    1
560    w
561    EOF
562     else
563     ## setup one bootable partition
564     #1. n= new disk
565     #2. p= primary disk
566     #3. 1= first partition
567     #4. ''= default sector start
568     #5. ''= defaul sector end
569     #6. a= bootable flag
570     #7. 1= boot flag for partition 1
571     #8. w= write/quit
572     fdisk ${HDD} &> /dev/null << EOF
573    n
574    p
575    1
576    
577    
578    a
579    1
580    w
581    EOF
582     fi
583     else
584     ## hdds partitionieren manuell
585     cfdisk ${HDD} || die
586     fi
587  }  }
588    
589  setup_hdd_format_flash()  setup_hdd_format()
590  {  {
591   mke2fs -j -q ${ROOTHDD} || die   if [[ -n ${SWAPHDD} ]]
592     then
593     mkswap ${SWAPHDD} || die
594     fi
595     if [[ -n ${BOOTHDD} ]]
596     then
597     # f2fs is not grub/grub2 compatible
598     if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
599     then
600     mkfs.ext2 -q ${BOOTHDD} || die
601     else
602     mkfs.${FORMAT_FILESYSTEM} -q ${BOOTHDD} || die
603     fi
604     fi
605     if [[ -n ${ROOTHDD} ]]
606     then
607     mkfs.${FORMAT_FILESYSTEM} -q ${ROOTHDD} || die
608     fi
609  }  }
610    
611  install_mount_rootfs()  install_mount_rootfs()
612  {  {
613   swapon ${SWAPHDD} || die   local opts
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
614    
615  install_mount_rootfs_flash()   if [[ -n ${SWAPHDD} ]]
616  {   then
617   mount ${ROOTHDD} ${INSTALLPATH} || die   swapon ${SWAPHDD} || die
618   install -d ${INSTALLPATH}/boot || die   fi
619   cd ${INSTALLPATH} || die   if [[ -n ${ROOTHDD} ]]
620     then
621     # be safe here, append file system type to mount
622     # just in case the f2fs module was not autoloaded
623     [[ ${FORMAT_FILESYSTEM} = f2fs ]] && opts="-t fs2fs"
624     mount ${opts} ${ROOTHDD} ${INSTALL_ROOT} || die
625     fi
626     if [[ -n ${BOOTHDD} ]]
627     then
628     install -d ${INSTALL_ROOT}/boot || die
629     mount ${BOOTHDD} ${INSTALL_ROOT}/boot || die
630     fi
631    
632     cd ${INSTALL_ROOT} || die
633  }  }
634    
635  install_system_image()  install_system_image()
636  {  {
637   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALL_ROOT}
638  }  }
639    
640  install_bootsector_chroot()  install_bootsector_chroot()
641  {  {
642   ### grubconf schreiben   local my_roothdd
643   source ${INSTALLPATH}/boot/kernelversion   local grubconf=${INSTALL_ROOT}/boot/grub/grub.conf
644     local grub2conf=/boot/grub/grub.cfg
645     local CONFIG
646    
647   #for alx only   # check for grub2
648   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [[ -f ${INSTALL_ROOT}/sbin/grub-mkconfig ]]
649   then   then
650   OLD_ALXVER="${ALXVER}"   # needed by grub-mkconfig on the first run
651   source ${INSTALLPATH}/etc/alx_version   if [[ ! -f ${INSTALL_ROOT}/boot/grub/video.lst ]]
652   KRNVER="ALX-${ALXVER}"   then
653   ALXVER="${OLD_ALXVER}"   install -m0644 ${INSTALL_ROOT}/lib/grub/*/video.lst ${INSTALL_ROOT}/boot/grub/video.lst || die
654   fi   fi
655    
656   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"   # set kernelopts
657   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"   if [[ -f ${INSTALL_ROOT}/etc/conf.d/grub ]]
658     then
659   echo "default 0" > ${INSTALLPATH}/boot/grub/grub.conf || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
660   echo "timeout 0" >> ${INSTALLPATH}/boot/grub/grub.conf ||die   sed -i "s:^\(export GRUB_GFXPAYLOAD_LINUX=\).*:\1\"${GRUB2GFXPAYLOAD}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
661     else
662   echo -e "\ntitle=${KRNVER}" >> ${INSTALLPATH}/boot/grub/grub.conf || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALL_ROOT}/etc/conf.d/grub || die
663   echo "root (hd0,0)" >> ${INSTALLPATH}/boot/grub/grub.conf || die   echo "export GRUB_GFXPAYLOAD_LINUX=\"${GRUB2GFXPAYLOAD}\"" >>  ${INSTALL_ROOT}/etc/conf.d/grub || die
664     fi
665   echo "kernel /boot/vmlinuz root=${ROOTHDD} quiet" >> ${INSTALLPATH}/boot/grub/grub.conf || die   CONFIG=${INSTALL_ROOT}/.installrc
666   echo "initrd /boot/initrd" >> ${INSTALLPATH}/boot/grub/grub.conf || die   clearconfig
667     addconfig 'grub-mkdevicemap'
668   # bootsector schreiben chrooted schreiben (lfs/magellan)   addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"
669   cat > ${INSTALLPATH}/root/.bashrc << CHROOTEOF   addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
670  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   addconfig "exit 0"
671  root (hd0,0)  
672  setup (hd0)   # grub-legacy
673  quit   else
674  EOF   ### grubconf schreiben
675  echo "MODULES=\"ext3 amd74xx piix sis5513 via82cxxx\"" > /etc/conf.d/mkinitrd   source ${INSTALL_ROOT}/boot/kernelversion
676  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g")  
677  exit 0   #for alx only
678  CHROOTEOF   if [ -e ${INSTALL_ROOT}/etc/alx_version ]
679     then
680   ## enters chroot   OLD_ALXVER="${ALXVER}"
681   mount -t proc proc ${INSTALLPATH}/proc   source ${INSTALL_ROOT}/etc/alx_version
682   mount -t sysfs sysfs ${INSTALLPATH}/sys   KRNVER="ALX-${ALXVER}"
683   mount -o bind /dev ${INSTALLPATH}/dev   ALXVER="${OLD_ALXVER}"
684   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.bashrc -i   fi
685   umount ${INSTALLPATH}/proc  
686   umount ${INSTALLPATH}/sys   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
687   umount ${INSTALLPATH}/dev   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
688   rm ${INSTALLPATH}/root/.bashrc   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
689    
690     # uuid support
691     if is_uuid_supported
692     then
693     my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
694     else
695     my_roothdd="${ROOTHDD}"
696     fi
697    
698     CONFIG="${grubconf}"
699     clearconfig
700     addconfig "default 0"
701     addconfig "timeout 3"
702     # using current root password
703     addconfig "password --md5 $(cat ${INSTALL_ROOT}/etc/shadow | grep root | cut -d: -f2)"
704     addconfig
705     addconfig "# normal boot"
706     addconfig "title ${KRNVER}"
707     addconfig "root (hd0,0)"
708     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
709     if is_initrd_supported
710     then
711     addconfig "initrd /boot/${KRNINITRD}"
712     fi
713     addconfig
714     addconfig "# admin boot"
715     addconfig "title ${KRNVER} - Re-run hardware-detection"
716     addconfig "lock"
717     addconfig "root (hd0,0)"
718     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
719     if is_initrd_supported
720     then
721     addconfig "initrd /boot/${KRNINITRD}"
722     fi
723     addconfig
724     addconfig "title ${KRNVER} - Reset *all* local settings"
725     addconfig "lock"
726     addconfig "root (hd0,0)"
727     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
728     if is_initrd_supported
729     then
730     addconfig "initrd /boot/${KRNINITRD}"
731     fi
732    
733     # write bootsector chrooted (lfs/magellan)
734     CONFIG=${INSTALL_ROOT}/.installrc
735     clearconfig
736     addconfig '/usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null'
737     addconfig 'root (hd0,0)'
738     addconfig 'setup (hd0)'
739     addconfig 'quit'
740     addconfig 'EOF'
741     addconfig 'exit 0'
742     fi
743    
744     ## enter chroot
745     enter_chroot_installrc
746  }  }
747    
748  install_system_settings()  is_initrd_supported()
749  {  {
750   # schreibe fstab   # only generate initrds if the cmd exists
751   echo -e "${BOOTHDD}\t/boot\text3\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   [[ -x ${INSTALL_ROOT}/sbin/mkinitrd ]] && return 0
752   echo -e "${ROOTHDD}\t/\text3\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   return 1
753   echo -e "${SWAPHDD}\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die  }
754   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
755   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  install_initrd_chroot()
756    {
757     local CONFIG
758    
759     # only generate initrds if the cmd exists
760     is_initrd_supported || return 0
761    
762     FSMODS="${FORMAT_FILESYSTEM}"
763     DISKMODS="sd_mod"
764     OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
765     PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
766     SATAMODS="sata_via sata_sis sata_nv"
767     DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
768     OTHERMODS=""
769     case ${SPECIALDEVICE} in
770     zotac_intel|i845) FBMODS=""; DRMMODS="i915" ;;
771     zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
772     rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
773     # not working with kms enabled drivers -> segfaults
774     #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
775     maxdata) FBMODS="" ;;
776     *) FBMODS="uvesafb" ;;
777     esac
778    
779     # add a filesystems recoqnized by the bootloader if the current ${FORMAT_FILESYSTEM} is not supported
780     case "${FORMAT_FILESYSTEM}" in
781     f2fs) FSMODS+=" ext2" ;;
782     esac
783    
784     if [[ ${FORMFACTOR} = laptop ]]
785     then
786     OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
787     fi
788    
789     # install an appropriate uvesafb.conf
790     CONFIG=${INSTALL_ROOT}/etc/modprobe.d/uvesafb.conf
791     clearconfig
792     addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
793    
794     # install an appropriate viafb.conf
795     CONFIG=${INSTALL_ROOT}/etc/modprobe.d/viafb.conf
796     clearconfig
797     addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
798    
799     # install an appropriate i810fb.conf
800     CONFIG=${INSTALL_ROOT}/etc/modprobe.d/i810fb.conf
801     clearconfig
802     addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
803    
804     CONFIG=${INSTALL_ROOT}/.installrc
805     clearconfig
806     addconfig 'echo "MODULES=\"${FSMODS} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd'
807     addconfig 'mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null'
808     addconfig 'exit 0'
809     ## enter chroot
810     enter_chroot_installrc
811    }
812    
813    is_uuid_supported()
814    {
815     # f2fs needs special treatments as the old busybox does not support this fs
816     # use the blkid from util-linux instead of busybox
817     if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
818     then
819     if [[ -x $(type -P blkid) ]]
820     then
821     return 0
822     fi
823     else
824     if [[ -x $(type -P busybox.mkinitrd) ]]
825     then
826     # only detect uuids if supported
827     if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
828     then
829     return 0
830     fi
831     fi
832     fi
833    
834     return 1
835  }  }
836    
837  install_system_settings_flash()  get_uuid()
838  {  {
839   # schreibe fstab   local UUID
840   echo -e "${ROOTHDD}\t/\text3\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die   local SEC_TYPE
841   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   local TYPE
842   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   local blkidcmd
843    
844     local dev="$1"
845     [[ -z ${dev} ]] && die "no dev given"
846    
847     # check if given device is already an UUID
848     if [[ ${dev/UUID=/}x != ${dev}x ]]
849     then
850     eval "${dev}"
851     else
852     # f2fs needs special treatments as the old busybox does not support this fs
853     # use the blkid from util-linux instead of busybox
854     if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
855     then
856     blkidcmd="blkid"
857     else
858     blkidcmd="busybox.mkinitrd blkid"
859     fi
860     eval $(${blkidcmd} ${dev} | grep "${dev}:" | sed 's/.*:\ //')
861     fi
862     echo "${UUID}"
863  }  }
864    
865  install_umount_rootfs()  install_system_settings()
866  {  {
867   cd /   # schreibe fstab
868   umount ${INSTALLPATH}/boot || die   if is_uuid_supported
869   umount ${INSTALLPATH} || die   then
870   swapoff ${SWAPHDD} || die   if [[ -n ${BOOTHDD} ]]
871     then
872     echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALL_ROOT}/etc/fstab || die
873     fi
874     if [[ -n ${ROOTHDD} ]]
875     then
876     echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
877     fi
878     else
879     if [[ -n ${BOOTHDD} ]]
880     then
881     echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALL_ROOT}/etc/fstab || die
882     fi
883     if [[ -n ${ROOTHDD} ]]
884     then
885     echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
886     fi
887     fi
888     # not needed busybox loads all with swapon -a, even if not mentioned in fstab
889     #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
890     echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
891     echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
892    
893     # install network config skeleton
894     install -m0644 ${INSTALL_ROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALL_ROOT}/etc/conf.d/ || die
895    
896     # intel framebufer quirk
897     if [[ -e /proc/fb ]]
898     then
899     if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
900     then
901     fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
902     if [[ ${fbdev} != 0 ]]
903     then
904     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALL_ROOT}/etc/splash/splash.conf || die
905     fi
906     fi
907     fi
908  }  }
909    
910  install_umount_rootfs_flash()  install_umount_rootfs()
911  {  {
912   cd /   cd /
913   umount ${INSTALLPATH} || die   if [[ -n ${BOOTHDD} ]]
914     then
915     umount ${INSTALL_ROOT}/boot || die
916     fi
917     if [[ -n ${ROOTHDD} ]]
918     then
919     umount ${INSTALL_ROOT} || die
920     fi
921     if [[ -n ${SWAPHDD} ]]
922     then
923     swapoff ${SWAPHDD} || die
924     fi
925  }  }
926    
927  install_do_reboot()  install_do_reboot()
# Line 472  install_do_reboot() Line 930  install_do_reboot()
930  }  }
931    
932  #################################################  #################################################
933  #     Install Ablauf Scripte #  #     Install Main Scripts #
934  #################################################  #################################################
935    
936  run_install_normal()  run_install()
937  {  {
938   dialog_setup_hdd_found_manuell   local method="$1"
939    
940     # setup install environment
941     export KERNELOPTS="${DEFAULT_KERNELOPTS}"
942     export GRUBLEGACYOPTS="${GRUBLEGACYOPTS}"
943     export GRUB2OPTS="${GRUB2OPTS}"
944     export GRUB2GFXPAYLOAD="${DEFAULT_GRUB2GFXPAYLOAD}"
945     export FORMFACTOR="${DEFAULT_FORMFACTOR}"
946     export FORMAT_FILESYSTEM="${DEFAULT_FORMAT_FILESYSTEM}"
947    
948     case "${method}" in
949     auto)
950     export INSTALL_METHOD="${method}"
951     ;;
952     normal)
953     export INSTALL_METHOD="${method}"
954     ;;
955     single)
956     export INSTALL_METHOD="${method}"
957     ;;
958     flash)
959     export FORMAT_FILESYSTEM="f2fs"
960     export INSTALL_METHOD="${method}"
961     ;;
962     *)
963     echo "Unknown install method '${method}', aborting."
964     exit 1
965     ;;
966     esac
967    
968     dialog_hardware_detection
969    
970   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions
971   dialog_setup_hdd_format   dialog_setup_hdd_format
972   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
973   install_mount_rootfs   install_mount_rootfs
974   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
975    
  dialog_install_bootsector  
  install_bootsector_chroot  
   
976   dialog_install_settings   dialog_install_settings
977   sleep 1   sleep 1
978   install_system_settings   install_system_settings
979   install_umount_rootfs   install_initrd_chroot
  dialog_install_successful  
 }  
   
 run_install_flash()  
 {  
  dialog_setup_hdd_found_manuell  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
980    
981   dialog_install_bootsector   dialog_install_bootsector
982   install_bootsector_chroot   install_bootsector_chroot
983    
984   dialog_install_settings   install_umount_rootfs
  sleep 1  
  install_system_settings_flash  
  install_umount_rootfs_flash  
985   dialog_install_successful   dialog_install_successful
986  }  }
987    
988    # set some proper traps
989    trap "trap_exit" SIGINT SIGQUIT
990    
991  dialog_main  dialog_main
992    
993  exit 0  exit 0

Legend:
Removed from v.527  
changed lines
  Added in v.6838